 /**
 * The List with Merge specification.
 * 
 * Project <A HREF = "http://gloss.di.fc.ul.pt/quest/"> Quest</A>.
 *
 * @author Antonia Lopes
 * @version 1.1 - 05/Fev/2013
 */
 
 specification ListWM[Mergeable]
 
  sorts
    ListWM[Mergeable]
    
  constructors
    make: --> ListWM[Mergeable];
    add: ListWM[Mergeable] Mergeable --> ListWM[Mergeable];
    
  observers
    get: ListWM[Mergeable] int -->? Mergeable;
    size: ListWM[Mergeable] --> int;
    set: ListWM[Mergeable] int Mergeable -->? ListWM[Mergeable];
    remove: ListWM[Mergeable] int -->? ListWM[Mergeable];
    mergeInRange: ListWM[Mergeable] int int -->? ListWM[Mergeable];
    
  others
    isEmpty: ListWM[Mergeable];
    
  domains
    L: ListWM[Mergeable];  
    I, J: int; 
    E: Mergeable;  
    get (L,I) if 0 <= I and I < size(L);
    set (L, I, E) if 0 <= I and I < size(L);
    remove (L,I) if 0 <= I and I < size(L);
    mergeInRange (L,I,J) if 0 <= I and  I < J and J < size(L);
    
  axioms
    L: ListWM[Mergeable];  
    I, J: int;  
    E, F: Mergeable;
    
    get(add(L,E),I) = E if I = 0;
    get(add(L,E),I) = get(L,I - 1) if I > 0;
    
    size(make()) = 0;
    size(add(L,E)) = 1 + size(L);
    
    set(add(L,E),I,F) = add(L,F) when I = 0 else add(set(L,I - 1,F),E);
    
    remove(add(L,E),I) = L when I = 0 else add(remove(L,I - 1),E);

    mergeInRange(add(L,E),I,J) = add(remove(L,0),merge(E,get(L,0))) 
    			if I = 0 and J = 1; 
    mergeInRange(add(L,E),I,J) = mergeInRange(add(remove(L,0), merge(E,get(L,0))),I,J - 1) 
                if I = 0 and J > 1;
    mergeInRange(add(L,E),I,J) = add(mergeInRange(L,I-1,J-1),E) 
                if I > 0;
     
    isEmpty(L) if size(L) = 0;	
    
end specification