/**
 * Interface that represents the notion of Mergeable (mutable) objects

 * @author Gloss
 * @version 1.0 30/Jan/2013
 * @param <E> Type
 */
public interface Mergeable<E> extends Cloneable{
	
	/**
	 * Merges this object with the given object
	 * @param e - element to merge
	 */
	void merge(E e);
	
	/**
	 * Returns a copy of this object
	 * 
	 * @return clone of the object
	 */
	E clone();
	
}